
// TrimitSMSDlg.cpp : implementation file

#include "stdafx.h"
#include "TrimitSMS.h"
#include "TrimitSMSDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About


class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

	// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CTrimitSMSDlg dialog




CTrimitSMSDlg::CTrimitSMSDlg(CWnd* pParent /*=NULL*/)
: CDialog(CTrimitSMSDlg::IDD, pParent)
, m_NRTEL(_T(""))
, m_MESAJ(_T(""))
, m_Com(_T(""))
, m_Speed(0)
, m_baudRate(_T(""))
, m_SelCom(_T(""))
, m_PIN(_T(""))
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTrimitSMSDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDOK, m_OK);
	DDX_Control(pDX, IDCANCEL, m_Cancel);
	DDX_Control(pDX, IDC_InitSer, m_InitCom);
	DDX_Control(pDX, IDC_SEND_DATA, m_SendData);
	DDX_Control(pDX, IDC_CLOSE_SER, m_Close);
	DDX_Text(pDX, IDC_EDIT1, m_NRTEL);
	DDX_Text(pDX, IDC_EDIT2, m_MESAJ);
	DDX_Control(pDX, IDC_STARER, m_Modem);
	DDX_Control(pDX, IDC_STAREM, m_Retea);
	DDX_Control(pDX, IDC_STARER, m_Modem);
	DDX_Control(pDX, IDC_STAREM, m_Retea);
	DDX_Text(pDX, IDC_COMPORT, m_Com);
	DDX_Control(pDX, IDC_COMPORT, m_SCOM);
	DDX_Text(pDX, IDC_SPEED, m_Speed);
	DDX_CBString(pDX, IDC_COMBO, m_baudRate);
	DDX_CBString(pDX, IDC_COMSEL, m_SelCom);
	DDV_MaxChars(pDX, m_MESAJ, 160);
	DDX_Text(pDX, IDC_EDIT4, m_PIN);
	DDX_Control(pDX, IDC_BUTTON_SendPIN, m_send_PIN);
	DDX_Control(pDX, IDC_CheckNetwork, m_CheckNetwork);
}

BEGIN_MESSAGE_MAP(CTrimitSMSDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_InitSer, &CTrimitSMSDlg::OnBnClickedInitser)
	ON_BN_CLICKED(IDC_SEND_DATA, &CTrimitSMSDlg::OnBnClickedSendData)
	ON_BN_CLICKED(IDC_CLOSE_SER, &CTrimitSMSDlg::OnBnClickedCloseSer)
	ON_BN_CLICKED(IDC_BUTTON_SendPIN, &CTrimitSMSDlg::OnBnClickedButtonSendpin)
	ON_BN_CLICKED(IDC_CheckNetwork, &CTrimitSMSDlg::OnBnClickedChecknetwork)
END_MESSAGE_MAP()


// CTrimitSMSDlg message handlers

BOOL CTrimitSMSDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	m_NRTEL = "Place phone number here";
	m_SelCom="COM1";
	m_baudRate = "9600";
	m_Speed=9600;
	UpdateData(FALSE);
	m_SendData.EnableWindow(FALSE);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTrimitSMSDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTrimitSMSDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTrimitSMSDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

HANDLE hSerPort1;

void CTrimitSMSDlg::OnBnClickedInitser()
{
UpdateData(TRUE);
	
	hSerPort1 = CreateFile( m_SelCom, GENERIC_READ | GENERIC_WRITE, 0, NULL, OPEN_EXISTING, 0, NULL);

	if(hSerPort1 == INVALID_HANDLE_VALUE) 
		AfxMessageBox(_T("Unable to open serial port !"), 0, MB_OK);
	else
	{
		//setting communication parameters
		COMMTIMEOUTS comTimeOut;                   

		comTimeOut.ReadIntervalTimeout			= 3;
		comTimeOut.ReadTotalTimeoutMultiplier	= 3;
		comTimeOut.ReadTotalTimeoutConstant		= 2;
		comTimeOut.WriteTotalTimeoutMultiplier	= 3;
		comTimeOut.WriteTotalTimeoutConstant	= 2;

		if(!SetCommTimeouts(hSerPort1, &comTimeOut))
		{
			AfxMessageBox(L"Unable to set port parameters !!!!", 0, MB_OK);
			return;
		}

		//setara param. si mod comunicatie
		DCB dcb;	//device block control

		if ( !GetCommState(hSerPort1, &dcb) )	//If the function fails, the return value is zero
		{
			AfxMessageBox(L"Unable to check parameters of port !!!!", 0, MB_OK);
			return;
		}

		dcb.DCBlength = sizeof(dcb);

#pragma region Set_baudRate
///////////////////////////////////////////////////////////
		char *my_m = new char[];
		sprintf(my_m,"%ls",m_baudRate.GetBuffer());
		switch(atoi(my_m))
		{
		case 110:
			dcb.BaudRate = 110;
			break;
		case 300:
			dcb.BaudRate = 300;
			break;
		case 600:
			dcb.BaudRate = 600;
			break;
		case 1200:
			dcb.BaudRate = 1200;
			break;
		case 2400:
			dcb.BaudRate = 2400;
			break;
		case 4800:
			dcb.BaudRate = 4800;
			break;
		case 9600:
			dcb.BaudRate = 9600;
			break;
		case 14400:
			dcb.BaudRate = 14400;
			break;
		case 19200:
			dcb.BaudRate = 19200;
			break;
		case 38400:
			dcb.BaudRate = 38400;
			break;
		case 56000:
			dcb.BaudRate = 56000;
			break;
		case 57600:
			dcb.BaudRate = 57600;
			break;
		case 115200 :
			dcb.BaudRate = 115200;
			break;
		case 128000:
			dcb.BaudRate = 128000;
			break;
		case 256000:
			dcb.BaudRate = 256000;
			break;
		default:
			break;
		}
////////////////////////////////////////////////////////////
#pragma endregion

		dcb.fBinary = 1;
		dcb.fParity = 0;						//daca TRUE atunci paritatea este verificata si 
		//mesaje de erori sunt generate - daca sunt
		dcb.fDtrControl = DTR_CONTROL_DISABLE;	//0, 1, 2
		//DTR_CONTROL_DISABLE, DTR_CONTROL_ENABLE, //DTR_CONTROL_HANDSHAKE
		dcb.fRtsControl = RTS_CONTROL_DISABLE;	//0, 1, 2, 3
		//RTS_CONTROL_DISABLE, RTS_CONTROL_ENABLE, RTS_CONTROL_HANDSHAKE, RTS_CONTROL_TOGGLE
		dcb.fOutxCtsFlow = 0;
		dcb.fOutxDsrFlow = 0; 
		dcb.Parity = 0;				//0-4= no, odd, even, mark, space
		dcb.StopBits = ONESTOPBIT;   //0,1,2 = 1, 1.5, 2 - ONESTOPBIT, ONE5STOPBITS, TWOSTOPBITS 
		dcb.ByteSize = 8;
		dcb.fNull = 0;				//If this member is TRUE, null bytes are discarded 
		//when received.

		if( !SetCommState(hSerPort1, &dcb) )   //If the function fails, the return value is zero
			AfxMessageBox(L"Unable to set parammetes !!!!", 0, MB_OK);
		
		//Check if GSM modem is connected !!!
		DWORD sizeBuff_w;
		DWORD sizeBuff_r;
		////////////////////////////////////////////////////////////////////////////
		char check_presence_buffer[100]={NULL};
		char check_presence[]={"at"};   
		DWORD dimpresence=strlen(check_presence);


		WriteFile(hSerPort1, check_presence, 2, &sizeBuff_w,NULL);	//send "at" comand
		TransmitCommChar(hSerPort1,'\r');							//send ENTER
		Sleep(200);

		ReadFile(hSerPort1, check_presence_buffer, 100, &sizeBuff_r, NULL); // read is updated with the number of bytes read
		Sleep(200);	

		if(strcmp(check_presence_buffer,"OK") == 1)				// if the answer of the modem is OK then
			m_Modem.SetWindowText(_T("Modem connected"));		// show Modem connected
		else
			m_Modem.SetWindowText(_T("Modem not connected"));	// show Modem is not connected

		//////////////////////////////////////////////////////////////////////////////////
		//Check if GSM modem is registered on network
		char check_network[]={"at+creg?"}; //at command used to check if the modem is registered on network
		char check_network_buffer[100]={NULL};
		DWORD dimCK=strlen(check_network);
		/////////////////////////////
		WriteFile(hSerPort1,check_network,dimCK,&sizeBuff_w,NULL);
		TransmitCommChar(hSerPort1,'\r');
		Sleep(200);

		ReadFile(hSerPort1, check_network_buffer, 100, &sizeBuff_r, NULL); // read is updated with the number of bytes read
		Sleep(500);	

		if( strstr(check_network_buffer,"0,1") != NULL )
			m_Retea.SetWindowText(_T("Network OK"));
		else
			m_Retea.SetWindowText(_T("No Network"));

		m_Cancel.EnableWindow(FALSE);
		m_OK.EnableWindow(FALSE);
		m_InitCom.EnableWindow(FALSE);
		m_Close.EnableWindow(TRUE);
		m_SendData.EnableWindow(TRUE);
		m_send_PIN.EnableWindow(TRUE);
		m_CheckNetwork.EnableWindow(TRUE);

		//errVal = GetLastError();  //take the last error
	}
}

void CTrimitSMSDlg::OnBnClickedSendData()
{
	// TODO: Add your control notification handler code here
	DWORD sizeBuffer;		//number of bytes needed to be written into port
	DWORD sizeWritten;		//actual number of bytes written into port
	DWORD size_msg;
	
	//To send a SMS: 
	// 
	// AT+CMGS=[number]\r[text]Control-Z : we have Control-Z with chr(26)
	// It returns OK or ERROR
	//
	CString com_s=_T("at+cmgs=");

	UpdateData(TRUE);		//retrieve dialog data
	CString comm_number = com_s + m_NRTEL; 

	//sequence I
	char *my_GSM_post = new char[];
	sprintf(my_GSM_post,"%ls",comm_number.GetBuffer());
	sizeBuffer = strlen( my_GSM_post );

	//sequence II
	char *my_SMS_post = new char[];
	sprintf(my_SMS_post,"%ls",m_MESAJ.GetBuffer());
	size_msg = strlen( my_SMS_post );

	// Send GSM command
	if ( WriteFile(hSerPort1, my_GSM_post, sizeBuffer, &sizeWritten, NULL) == 0 )
		AfxMessageBox(L"Unable to write information on port !!!", 0, MB_OK);
	TransmitCommChar(hSerPort1, '\r');

	Sleep(2000);
	
	// Send SMS text
	if ( WriteFile(hSerPort1, my_SMS_post, size_msg, &sizeWritten, NULL) == 0 )
		AfxMessageBox(L"Unable to write information on port !!!", 0, MB_OK);
	TransmitCommChar(hSerPort1, 26);
	
	///////////////////////////////////////////////////////////////////////////
	MessageBox(m_MESAJ);
}

void CTrimitSMSDlg::OnBnClickedCloseSer()
{
	if(CloseHandle(hSerPort1) == 0)    
		AfxMessageBox(L"Unable to close serial port !!!!", 0, MB_OK);

	m_Modem.SetWindowText(_T("Modem disconnected"));
	m_Retea.SetWindowText(_T("No Network"));
	m_Cancel.EnableWindow(TRUE);
	m_OK.EnableWindow(TRUE);
	m_InitCom.EnableWindow(TRUE);
	m_Close.EnableWindow(FALSE);
	m_SendData.EnableWindow(FALSE);
	m_send_PIN.EnableWindow(FALSE);
	m_CheckNetwork.EnableWindow(FALSE);
}


void CTrimitSMSDlg::OnBnClickedButtonSendpin()
{
	// TODO: Add your control notification handler code here
	DWORD sizeBuffer;				// number of bytes needed to be written into port
	DWORD sizeBuff_w;				// buffer length written
	DWORD sizeBuff_r;

	CString m_CommPin = _T("at+cpin="); 

	UpdateData(TRUE);				// retrieve PIN dialog data
	m_CommPin = m_CommPin + m_PIN;	// compose the final string

	char *my_Comm_Pin = new char[];
	sprintf(my_Comm_Pin,"%ls",m_CommPin.GetBuffer());
	sizeBuffer = strlen( my_Comm_Pin );
	

	char check_presence_buffer[100]={NULL};

	WriteFile(hSerPort1, my_Comm_Pin, sizeBuffer, &sizeBuff_w, NULL); //send "at+cpin=????" comand
	TransmitCommChar(hSerPort1, '\r');  //send ENTER
	Sleep(200);

	ReadFile(hSerPort1, check_presence_buffer, 100, &sizeBuff_r, NULL); // read is updated with the number of bytes read
	Sleep(200);	

	if( strstr(check_presence_buffer,"OK") != NULL)				// if the answer of the modem is OK then
		m_Modem.SetWindowText(_T("PIN value accepted"));	// show PIN accepted
	else
		m_Modem.SetWindowText(_T("PIN not accepted"));		// The pin was not accepted
}

void CTrimitSMSDlg::OnBnClickedChecknetwork()
{
	// TODO: Add your control notification handler code here
	DWORD sizeBuff_w, sizeBuff_r;

	char check_network[]={"at+creg?"}; //at command used to check if the modem is registered on network
	char check_network_buffer[100]={NULL};
	DWORD dimCK=strlen(check_network);

	/////////////////////////////
	WriteFile(hSerPort1,check_network,dimCK,&sizeBuff_w,NULL);
	TransmitCommChar(hSerPort1,'\r');
	Sleep(200);

	ReadFile(hSerPort1, check_network_buffer, 100, &sizeBuff_r, NULL); // read is updated with the number of bytes read
	Sleep(500);	

	if( strstr(check_network_buffer,"0,1")!=NULL)
		m_Retea.SetWindowText(_T("Network OK"));
	else
		m_Retea.SetWindowText(_T("No Network"));
}
